import { world, system } from "@minecraft/server";

const breath = {
  "aether_dragon": "bj:air1breath",
  "nether_dragon": "bj:netherbreath",
  "ice_dragon": "bj:icebreath",
  "moonlight_dragon": "bj:icebreath",
  "water_dragon": "bj:waterbreath",
  "sunlight_dragon": "bj:firebreath",
  "storm_dragon": "bj:airbreath",
  "forest_dragon": "bj:poisonbreath",
  "zombie_dragon": "bj:poisonbreath",
  "wither_dragon": "bj:witherbreath",
  "enchant_dragon": "bj:firebreath",
  "phantom_dragon": "bj:airbreath",
  "fire_dragon": "bj:firebreath",
  "ender_dragon": "bj:enderbreath",
  "skeleton_dragon": "bj:firebreath",
  "terra_dragon": "bj:firebreath",
  "dark_dragon": "bj:netherbreath",
  "f_aether_dragon": "bj:air1breath",
  "f_nether_dragon": "bj:netherbreath",
  "f_water_dragon": "bj:waterbreath",
  "f_moonlight_dragon": "bj:icebreath",
  "f_dark_dragon": "bj:firebreath",
  "f_ice_dragon": "bj:icebreath",
  "f_forest_dragon": "bj:poisonbreath",
  "f_sunlight_dragon": "bj:firebreath",
  "f_fire_dragon": "bj:firebreath",
  "f_terra_dragon": "bj:firebreath",
  "f_storm_dragon": "bj:airbreath",
  "f_enchant_dragon": "bj:firebreath",
  "m_ender_dragon": "bj:enderbreath",
  "r_fire_dragon": "bj:firebreath",
  "f_phantom_dragon": "bj:airbreath"
};

world.afterEvents.itemUse.subscribe(e => {
  const p = e.source;
  if (e.itemStack.typeId !== "bj:dg_whistle") return;

  const r = p.getComponent("minecraft:riding")?.entityRidingOn;
  if (!r) return;

  const t = breath[r.typeId.split(":")[1]];
  if (!t) return;

  const d = p.getViewDirection();
  const l = { x: p.location.x + d.x, y: p.location.y + 1.5 + d.y, z: p.location.z + d.z };
  const b = p.dimension.spawnEntity(t, l);
  if (!b) return;

  system.runTimeout(() => {
    b.applyImpulse({ x: d.x * 1.5, y: d.y * 1.5, z: d.z * 1.5 });
  }, 1);

  p.playSound("bj.dragon.firebreath", { location: p.location, volume: 1 });
  p.playAnimation("attack");
});